package com.playmore.util.snowflake;

import com.playmore.util.snowflake.SnowflakeUtil;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SnowflakeTestThread extends Thread {

   private Logger LOGGER = LoggerFactory.getLogger(this.getClass());
   int serverId;
   SnowflakeUtil util;
   int count;
   Map map;


   public SnowflakeTestThread(SnowflakeUtil util, int serverId, int count, Map map) {
      super.setName("SnowflakeTestThread-" + serverId);
      this.serverId = serverId;
      this.count = count;
      this.util = util;
      this.map = map;
   }

   public void run() {
      this.LOGGER.info(Thread.currentThread().getName() + " 开始执行！");
      boolean isRepeated = false;

      for(int i = 0; i < this.count; ++i) {
         long id = this.util.next();
         if(this.map.containsKey(Long.valueOf(id))) {
            this.LOGGER.error(Thread.currentThread().getName() + " id重复   id:" + id + " i=" + i + "  oldServerId:" + this.map.get(Long.valueOf(id)));
            isRepeated = true;
            break;
         }

         if((i + 1) % 10000 == 0) {
            this.LOGGER.info(Thread.currentThread().getName() + " 执行到第 " + (i + 1) / 10000 + " 万次");
         }

         this.map.put(Long.valueOf(id), Integer.valueOf(this.serverId));
      }

      this.LOGGER.info(Thread.currentThread().getName() + " 执行完毕！isRepeated:" + isRepeated);
   }

   public static void main(String[] args) {
      byte serverNum = 10;
      int count = 100000000;
      ConcurrentHashMap map = new ConcurrentHashMap();
      new SnowflakeUtil(1L);

      for(int i = 0; i < serverNum; ++i) {
         int serverId = i + 1;
         SnowflakeUtil util = new SnowflakeUtil((long)serverId);
         SnowflakeTestThread thread = new SnowflakeTestThread(util, serverId, count, map);
         thread.start();
      }

   }
}
